/**
 * grid-menu.js
 *
 * @author     James Brumond
 * @version    0.0.1
 * @copyright  Copyright 2011 James Brumond
 * @license    Dual licensed under MIT and GPL
 */

var GridMenu = (function() {
	
	// Default configuration settings for GridMenu
	var _defaultConfig = {
		rows: 0,
		cols: 0,
		width: null,
		height: null,
		items: [ ],
		strategy: 'alignStrict',
		dragDelay: 1000
	};
	
	// Default item values
	var _defaultItem = {
		contents: null,
		onselect: null,
		ondragstart: null,
		ondrag: null,
		ondragend: null
	};
	
	// Is this a touch device?
	var touchEvents = (function() {
		var ret, elem = document.createElement('div');
		ret = ('ontouchstart' in elem);
		elem = null;
		return ret;
	}());
	
	// A class to add when an element is being dragged
	var dragClass = 'drag';
	
	// Determine the events to bind to
	var events = (touchEvents ?
		{
			start: 'touchstart',
			move: 'touchmove',
			end: 'touchend'
		} : {
			start: 'mousedown',
			move: 'mousemove',
			end: 'mouseup'
		}
	);

